
DECLARE
  v_exists INTEGER;
BEGIN

 SELECT count(*) 
    INTO v_exists 
    FROM user_tables 
    WHERE UPPER(Table_Name)='LAYERDATA_DOCINFO';
    
 IF v_exists=0 THEN

EXECUTE IMMEDIATE '
CREATE TABLE LayerData_DocInfo
(
  ID NUMBER(10,0) NOT NULL, 
	LAYERREF NUMBER(10,0) NOT NULL, 
	LAYERVERSION NUMBER(10,0), 
	FACIALACCCLS NUMBER(10,0), 
  SENDERID NUMBER(10,0), 
	SENDERRECORDID NUMBER(10,0), 
  SENDERID_FORCHECK NUMBER(10,0),
	RVERSION NUMBER(10,0), 
	CREATEDATE DATE NOT NULL, 
	CREATERUSER VARCHAR2(30) NOT NULL, 
	UPDATEDATE DATE NOT NULL, 
	UPDATERUSER VARCHAR2(30) NOT NULL, 
	TASKREF NUMBER(10,0), 
  PRODUCTREF NUMBER(10,0), 
	OWNERUSER NUMBER(10,0) DEFAULT null NOT NULL, 
	EXECUTERUSER NUMBER(10,0) DEFAULT null NOT NULL, 
	UPDATESTATUS NUMBER(10,0), 
  UPDATEDRECORDINDEX NUMBER(10,0), 
	UPDATEGROUPINDEX NUMBER(10,0), 
  ACCEPTDATE NUMBER, 
	REJECTDATE NUMBER, 
	REJECTCAUSE VARCHAR2(255), 
	NATURALKEY VARCHAR2(255), 
	DOCSTATEREF NUMBER(10,0), 
	CRYPTOSTATUS NUMBER(10,0), 
	LOCKSTATUS NUMBER(2,0), 
	LOCKINFO VARCHAR2(255), 
	DATEOPEN NUMBER, 
	DATECLOSE NUMBER, 
	BUDGETREF NUMBER(10,0),
  
    /* */
    DocLayerVersion NUMBER(10,0),
    DocLayerRef NUMBER(10,0),
    DocTextInfo1 VARCHAR2(1024),
    DocTextInfo2 VARCHAR2(1024),
    DocTextInfo3 VARCHAR2(1024),
    DocTextInfo4 VARCHAR2(1024), 
    SchemaName VARCHAR2(1024), 
    DocLayerAlias VARCHAR2(256),
    DocDate  NUMBER,  
    DocNK VARCHAR2(256),
    UserName VARCHAR2(64),
    StartState VARCHAR2(1024),
    EndState VARCHAR2(1024),

     /*  */
    INTFIELD00 NUMBER(10,0), 
    INTFIELD01 NUMBER(10,0), 
    INTFIELD02 NUMBER(10,0), 
    INTFIELD03 NUMBER(10,0), 
    INTFIELD04 NUMBER(10,0), 
    INTFIELD05 NUMBER(10,0),
    INTFIELD06 NUMBER(10,0), 
    INTFIELD07 NUMBER(10,0),
    DATEFIELD00 NUMBER,
    DATEFIELD01 NUMBER,
    DATEFIELD02 NUMBER,
    DATEFIELD03 NUMBER,
    SUMFIELD00          NUMBER(15,2) default null /* NUMBER(15,2) = NUMERIC(15,2) default 0 */,
    SUMFIELD01          NUMBER(15,2) default null /* NUMBER(15,2) = NUMERIC(15,2) default 0 */,
    SUMFIELD02          NUMBER(15,2) default null /* NUMBER(15,2) = NUMERIC(15,2) default 0 */,
    SUMFIELD03          NUMBER(15,2) default null /* NUMBER(15,2) = NUMERIC(15,2) default 0 */,
    FLOATFIELD00 NUMBER,
    FLOATFIELD01 NUMBER,
  
   CONSTRAINT "PK_LD_DocInfo" PRIMARY KEY ("ID"),
 
   CHECK ((ID<=2147483647)AND(ID>-2147483648)) , 
   CHECK ((LayerRef<=2147483647)AND(LayerRef>-2147483648)) , 
	 CHECK ((LayerVersion<=2147483647)AND(LayerVersion>-2147483648)) , 
   CHECK ((CryptoStatus<=2147483647)AND(CryptoStatus>-2147483648)) , 
	 CHECK ((DocStateRef<=2147483647)AND(DocStateRef>-2147483648)) , 
	 CHECK ((ExecuterUser<=2147483647)AND(ExecuterUser>-2147483648)) , 
	 CHECK ((FacialAccCls<=2147483647)AND(FacialAccCls>-2147483648)) ,
   CHECK ((OwnerUser<=2147483647)AND(OwnerUser>-2147483648)) , 
   CHECK ((TASKREF<=2147483647)AND(TASKREF>-2147483648)) , 
	 CHECK ((ProductRef<=2147483647)AND(ProductRef>-2147483648)) ,
   CHECK ((Rversion<=2147483647)AND(Rversion>-2147483648)) , 
	 CHECK ((SenderID<=2147483647)AND(SenderID>-2147483648)) , 
	 CHECK ((SenderRecordID<=2147483647)AND(SenderRecordID>-2147483648)) , 
   CHECK ((UpdatedRecordIndex<=2147483647) and (UpdatedRecordIndex>=-2147483648)) , 
	 CHECK ((UpdateGroupIndex<=2147483647) and (UpdateGroupIndex>=-2147483648)) , 
	 CHECK ((UpdateStatus<=2147483647) and (UpdateStatus>=-2147483648)) , 
   CHECK ((SENDERID_FORCHECK<=2147483647) and (SENDERID_FORCHECK>=-2147483648)) , 
	 CHECK ((BUDGETREF<=2147483647)AND(BUDGETREF>-2147483648)) ,
   
    CHECK((DocLayerVersion<=2147483647)AND(DocLayerVersion>-2147483648)),
    CHECK((DocLayerRef<=2147483647)AND(DocLayerRef>-2147483648)),
    
    CHECK((INTFIELD00<=2147483647)AND(INTFIELD00>-2147483648)),
    CHECK((INTFIELD01<=2147483647)AND(INTFIELD01>-2147483648)),
    CHECK((INTFIELD02<=2147483647)AND(INTFIELD02>-2147483648)),
    CHECK((INTFIELD03<=2147483647)AND(INTFIELD03>-2147483648)),
    CHECK((INTFIELD04<=2147483647)AND(INTFIELD04>-2147483648)),
    CHECK((INTFIELD05<=2147483647)AND(INTFIELD05>-2147483648)),
    CHECK((INTFIELD06<=2147483647)AND(INTFIELD06>-2147483648)),
    CHECK((INTFIELD07<=2147483647)AND(INTFIELD07>-2147483648)),
    
    
	 CONSTRAINT FK_LD_DocInfo_TASKREF FOREIGN KEY (TASKREF)
	  REFERENCES LAYERTASKS (ID) , 
	 CONSTRAINT FK_LD_DocInfo_EXECUTER FOREIGN KEY (EXECUTERUSER)
	  REFERENCES TB_DBUSERS (ID) , 
	 CONSTRAINT FK_LD_DocInfo_OWNER FOREIGN KEY (OWNERUSER)
	  REFERENCES TB_DBUSERS (ID) , 
	 CONSTRAINT FK_LD_DocInfo_LAYERREF FOREIGN KEY (LAYERREF)
	  REFERENCES LAYERS (ID),
	 CONSTRAINT FK_LD_DocInfo_FACIALACCCLS FOREIGN KEY (FACIALACCCLS)
	  REFERENCES TB_FACIALACC_CLS (ID)   
)';

  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_DocInfo_BUDGETREF ON LAYERDATA_DocInfo (BUDGETREF)';
  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_DocInfo_LAYER ON LAYERDATA_DocInfo (LAYERREF, LAYERVERSION)';
/*    */
  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_DocInfo_DocLayerAlias ON LAYERDATA_DocInfo (DocLayerAlias)';
  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_DocInfo_DocLayer ON LAYERDATA_DocInfo (DocLayerRef)';
  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_DocInfo_DocVersion ON LAYERDATA_DocInfo (DocLayerVersion)';

  EXECUTE IMMEDIATE 'GRANT ALL ON LAYERDATA_DocInfo TO PUBLIC';
  
  EXECUTE IMMEDIATE 'COMMIT WORK';

END IF;

END;
/



CREATE OR REPLACE TRIGGER TR_LD_DocInfo_BI
 BEFORE
  INSERT
 ON LayerData_DocInfo
 FOR EACH ROW
declare
  fac NUMBER(10);
begin

-- - - - - - - - - - - - -
-- BI_(0)
-- Create 05.09.2005
-- Last Update 22.05.2009
-- - - - - - - - - - - - -

    if (:new.id is null) then select g_Shared.nextval into :new.Id from DUAL; end if;
    if (:new.LayerVersion is null) then :new.LayerVersion := 0; end if;
    if (:new.ExecuterUser is null) then :new.ExecuterUser := :new.OwnerUser; end if;
    
-- - - - - - - - - - - - -
-- BI_500
-- Create 05.09.2005
-- - - - - - - - - - - - -
  :NEW.CreateDate := SYSDATE;
  :NEW.UpdateDate := :NEW.CreateDate;
  :NEW.CreaterUser := USER;
  :NEW.UpdaterUser := USER;
end;

/

CREATE OR REPLACE TRIGGER TR_LD_DocInfo_BU
 BEFORE
  UPDATE
 ON LayerData_DocInfo
 FOR EACH ROW
begin

-- - - - - - - - - - - - -
-- BU_(0)
-- Create 05.09.2005
-- - - - - - - - - - - - -

    if (:new.LayerVersion is null) then :new.LayerVersion := 0; end if;
    if (:new.ExecuterUser is null) then :new.ExecuterUser := :new.OwnerUser; end if;
    
-- - - - - - - - - - - - -
-- BU_700
-- Create 05.09.2005
-- - - - - - - - - - - - -

  if (:new.RVersion is null) then
    :new.RVersion := 1;
  elsif ((:new.RVersion = -1) and (:old.RVersion <> -1)) then
    :new.RVersion := :old.RVersion;
  else
    :new.RVersion := :old.RVersion+1;
  end if;

end;

/
CREATE OR REPLACE TRIGGER TR_LD_DocInfo_BU_500 before update on LayerData_DocInfo for each row
begin
-- - - - - - - - - - - - -
-- BU_500
-- - - - - - - - - - - - -
    :new.UpdateDate := SYSDATE;
    :new.UpdaterUser := User;
end;

/

