
DECLARE
  v_exists INTEGER;
BEGIN

 SELECT count(*) 
    INTO v_exists 
    FROM user_tables 
    WHERE UPPER(Table_Name)='LAYERDATA_RRO';
    
 IF v_exists=0 THEN

EXECUTE IMMEDIATE '
CREATE TABLE LayerData_RRO
(
  ID NUMBER(10,0) NOT NULL, 
	LAYERREF NUMBER(10,0) NOT NULL, 
	LAYERVERSION NUMBER(10,0), 
	FACIALACCCLS NUMBER(10,0), 
  SENDERID NUMBER(10,0), 
	SENDERRECORDID NUMBER(10,0), 
  SENDERID_FORCHECK NUMBER(10,0),
	RVERSION NUMBER(10,0), 
	CREATEDATE DATE NOT NULL, 
	CREATERUSER VARCHAR2(30) NOT NULL, 
	UPDATEDATE DATE NOT NULL, 
	UPDATERUSER VARCHAR2(30) NOT NULL, 
	TASKREF NUMBER(10,0), 
  PRODUCTREF NUMBER(10,0), 
	OWNERUSER NUMBER(10,0) DEFAULT null NOT NULL, 
	EXECUTERUSER NUMBER(10,0) DEFAULT null NOT NULL, 
	UPDATESTATUS NUMBER(10,0), 
  UPDATEDRECORDINDEX NUMBER(10,0), 
	UPDATEGROUPINDEX NUMBER(10,0), 
  ACCEPTDATE NUMBER, 
	REJECTDATE NUMBER, 
	REJECTCAUSE VARCHAR2(255), 
	NATURALKEY VARCHAR2(255), 
	DOCSTATEREF NUMBER(10,0), 
	CRYPTOSTATUS NUMBER(10,0), 
	LOCKSTATUS NUMBER(2,0), 
	LOCKINFO VARCHAR2(255), 
	DATEOPEN NUMBER, 
	DATECLOSE NUMBER, 
	BUDGETREF NUMBER(10,0),
  
    PONUM  NUMBER(10,0),
    POCODE NUMBER(10,0),
    REGIONCLS           NUMBER(10,0),
    BUDGETLEVEL  NUMBER(10,0),
    INDEXNUM    NUMBER(10,0),
    DOCDATE     NUMBER,
    DOCTYPE NUMBER(10,0),
    AUTHCODE  NUMBER(10,0),
    CALCMETHCODE NUMBER(10,0),
    
    
     /* */
    KVSR                NUMBER(10,0),
    KVR                 NUMBER(10,0),
    KFSR                NUMBER(10,0),    
    FINSOURCE           NUMBER(10,0),
    MEANSTYPE           NUMBER(10,0),
    SUBSIDYCLS          NUMBER(10,0),
    TRANSFERTCLS        NUMBER(10,0) /* NUMBER(10,0) = INTEGER */,
    KCSR                varchar2(20) /* varchar2(20 = VARCHAR(20) */,
    NAZPROJ             varchar2(10),
    INVESTOBJECT        varchar2(20) /* varchar2(20 = VARCHAR(20) */,
    FINTYPE             varchar2(20) /* varchar2(20 = VARCHAR(20) */,
    OKPD                NUMBER(10,0) /* NUMBER(10,0) = INTEGER */,
    FACT                varchar2(20) /* varchar2(20 = VARCHAR(20) */,
    DIRECTIONCLS        varchar2(20) /* varchar2(20 = VARCHAR(20) */,
    CONTRACTCOSTCLS     varchar2(20) /* varchar2(20 = VARCHAR(20) */,
    TARGETCLS           varchar2(20) /* varchar2(20 = VARCHAR(20) */,
    KESR                varchar2(20) /* varchar2(20 = VARCHAR(20) */,
    SUBKESR             varchar2(20) /* varchar2(20 = VARCHAR(20) */,
    DEPARTMENTCLS       NUMBER(10,0) /* NUMBER(10,0) = INTEGER */,
    OBLIGSTATUS         NUMBER(10,0),

     /*  */
    INTFIELD00 NUMBER(10,0), 
    INTFIELD01 NUMBER(10,0), 
    INTFIELD02 NUMBER(10,0), 
    INTFIELD03 NUMBER(10,0), 
    INTFIELD04 NUMBER(10,0), 
    INTFIELD05 NUMBER(10,0),
    INTFIELD06 NUMBER(10,0), 
    INTFIELD07 NUMBER(10,0),
    INTFIELD08 NUMBER(10,0),
    INTFIELD09 NUMBER(10,0),
    INTFIELD10 NUMBER(10,0),
    INTFIELD11 NUMBER(10,0),
    INTFIELD12 NUMBER(10,0),
    INTFIELD13 NUMBER(10,0),
    INTFIELD14 NUMBER(10,0),
    INTFIELD15 NUMBER(10,0),
    INTFIELD16          NUMBER(10,0) /* NUMBER(10,0) = INTEGER */,
    INTFIELD17          NUMBER(10,0) /* NUMBER(10,0) = INTEGER */,
    INTFIELD18          NUMBER(10,0) /* NUMBER(10,0) = INTEGER */,
    INTFIELD19          NUMBER(10,0) /* NUMBER(10,0) = INTEGER */,
    INTFIELD20          NUMBER(10,0) /* NUMBER(10,0) = INTEGER */,
    INTFIELD21          NUMBER(10,0) /* NUMBER(10,0) = INTEGER */,
    INTFIELD22          NUMBER(10,0) /* NUMBER(10,0) = INTEGER */,
    DATEFIELD00 NUMBER,
    DATEFIELD01 NUMBER,
    DATEFIELD02 NUMBER,
    DATEFIELD03 NUMBER,
    DATEFIELD04 NUMBER,
    DATEFIELD05 NUMBER,
    STRFIELD00 varchar2(1024), 
    STRFIELD01 varchar2(1024), 
    STRFIELD02 varchar2(1024), 
    STRFIELD03 varchar2(1024), 
    STRFIELD04 varchar2(1024),
    STRFIELD05 varchar2(1024),
    STRFIELD06 varchar2(1024),
    STRFIELD07 varchar2(1024),
    STRFIELD08 varchar2(1024),
    STRFIELD09 varchar2(1024), 
    STRFIELD10 varchar2(1024), 
    STRFIELD11 varchar2(1024), 
    STRFIELD12 varchar2(1024), 
    STRFIELD13 varchar2(1024),
    STRFIELD14 varchar2(1024),
    STRFIELD15 varchar2(1024),
    STRFIELD16 varchar2(1024),
    STRFIELD17 varchar2(1024),
    STRFIELD18 varchar2(1024),
    STRFIELD19 varchar2(1024),
    STRFIELD20 varchar2(1024),
    STRFIELD21 varchar2(1024),
    STRFIELD22 varchar2(1024),
    STRFIELD23 varchar2(1024),
    STRFIELD24 varchar2(1024),
    SUMFIELD00          NUMBER(15,2) default null /* NUMBER(15,2) = NUMERIC(15,2) default 0 */,
    SUMFIELD01          NUMBER(15,2) default null /* NUMBER(15,2) = NUMERIC(15,2) default 0 */,
    SUMFIELD02          NUMBER(15,2) default null /* NUMBER(15,2) = NUMERIC(15,2) default 0 */,
    SUMFIELD03          NUMBER(15,2) default null /* NUMBER(15,2) = NUMERIC(15,2) default 0 */,
    SUMFIELD04          NUMBER(15,2) default null /* NUMBER(15,2) = NUMERIC(15,2) default 0 */,
    SUMFIELD05          NUMBER(15,2) default null /* NUMBER(15,2) = NUMERIC(15,2) default 0 */,
    SUMFIELD06          NUMBER(15,2) default null /* NUMBER(15,2) = NUMERIC(15,2) default 0 */,
    SUMFIELD07          NUMBER(15,2) default null /* NUMBER(15,2) = NUMERIC(15,2) default 0 */,
    SUMFIELD08          NUMBER(15,2) default null /* NUMBER(15,2) = NUMERIC(15,2) default 0 */,
    SUMFIELD09          NUMBER(15,2) default null /* NUMBER(15,2) = NUMERIC(15,2) default 0 */,
    SUMFIELD10          NUMBER(15,2) default null /* NUMBER(15,2) = NUMERIC(15,2) default 0 */,
    SUMFIELD11          NUMBER(15,2) default null /* NUMBER(15,2) = NUMERIC(15,2) default 0 */,
    SUMFIELD12          NUMBER(15,2) default null /* NUMBER(15,2) = NUMERIC(15,2) default 0 */,
    SUMFIELD13          NUMBER(15,2) default null /* NUMBER(15,2) = NUMERIC(15,2) default 0 */,
    SUMFIELD14          NUMBER(15,2) default null /* NUMBER(15,2) = NUMERIC(15,2) default 0 */,
    SUMFIELD15          NUMBER(15,2) default null /* NUMBER(15,2) = NUMERIC(15,2) default 0 */,
    SUMFIELD16          NUMBER(15,2) default null /* NUMBER(15,2) = NUMERIC(15,2) default 0 */,
    SUMFIELD17          NUMBER(15,2) default null /* NUMBER(15,2) = NUMERIC(15,2) default 0 */,
    SUMFIELD18          NUMBER(15,2) default null /* NUMBER(15,2) = NUMERIC(15,2) default 0 */,
    SUMFIELD19          NUMBER(15,2) default null /* NUMBER(15,2) = NUMERIC(15,2) default 0 */,
    SUMFIELD20          NUMBER(15,2) default null /* NUMBER(15,2) = NUMERIC(15,2) default 0 */,
    SUMFIELD21          NUMBER(15,2) default null /* NUMBER(15,2) = NUMERIC(15,2) default 0 */,
    SUMFIELD22          NUMBER(15,2) default null /* NUMBER(15,2) = NUMERIC(15,2) default 0 */,
    SUMFIELD23          NUMBER(15,2) default null /* NUMBER(15,2) = NUMERIC(15,2) default 0 */,
    SUMFIELD24          NUMBER(15,2) default null /* NUMBER(15,2) = NUMERIC(15,2) default 0 */,
    SUMFIELD25          NUMBER(15,2) default null /* NUMBER(15,2) = NUMERIC(15,2) default 0 */,
    SUMFIELD26          NUMBER(15,2) default null /* NUMBER(15,2) = NUMERIC(15,2) default 0 */,
    SUMFIELD27          NUMBER(15,2) default null /* NUMBER(15,2) = NUMERIC(15,2) default 0 */,
    SUMFIELD28          NUMBER(15,2) default null /* NUMBER(15,2) = NUMERIC(15,2) default 0 */,
    SUMFIELD29          NUMBER(15,2) default null,
    SUMFIELD30          NUMBER(15,2) default null /* NUMBER(15,2) = NUMERIC(15,2) default 0 */,
    SUMFIELD31          NUMBER(15,2) default null /* NUMBER(15,2) = NUMERIC(15,2) default 0 */,
    SUMFIELD32          NUMBER(15,2) default null /* NUMBER(15,2) = NUMERIC(15,2) default 0 */,
    SUMFIELD33          NUMBER(15,2) default null /* NUMBER(15,2) = NUMERIC(15,2) default 0 */,
    SUMFIELD34          NUMBER(15,2) default null /* NUMBER(15,2) = NUMERIC(15,2) default 0 */,
    FLOATFIELD00 NUMBER,
    FLOATFIELD01 NUMBER,
    FLOATFIELD02 NUMBER, 
    FLOATFIELD03 NUMBER, 
    FLOATFIELD04 NUMBER,
    FLOATFIELD05 NUMBER,
    FLOATFIELD06        NUMBER /* DBLVALUE = DOUBLE PRECISION */,
    FLOATFIELD07        NUMBER /* DBLVALUE = DOUBLE PRECISION */,
  
   CONSTRAINT "PK_LD_RRO" PRIMARY KEY ("ID"),
 
   CHECK ((ID<=2147483647)AND(ID>-2147483648)) , 
   CHECK ((LayerRef<=2147483647)AND(LayerRef>-2147483648)) , 
	 CHECK ((LayerVersion<=2147483647)AND(LayerVersion>-2147483648)) , 
   CHECK ((CryptoStatus<=2147483647)AND(CryptoStatus>-2147483648)) , 
	 CHECK ((DocStateRef<=2147483647)AND(DocStateRef>-2147483648)) , 
	 CHECK ((ExecuterUser<=2147483647)AND(ExecuterUser>-2147483648)) , 
	 CHECK ((FacialAccCls<=2147483647)AND(FacialAccCls>-2147483648)) ,
   CHECK ((OwnerUser<=2147483647)AND(OwnerUser>-2147483648)) , 
   CHECK ((TASKREF<=2147483647)AND(TASKREF>-2147483648)) , 
	 CHECK ((ProductRef<=2147483647)AND(ProductRef>-2147483648)) ,
   CHECK ((Rversion<=2147483647)AND(Rversion>-2147483648)) , 
	 CHECK ((SenderID<=2147483647)AND(SenderID>-2147483648)) , 
	 CHECK ((SenderRecordID<=2147483647)AND(SenderRecordID>-2147483648)) , 
   CHECK ((UpdatedRecordIndex<=2147483647) and (UpdatedRecordIndex>=-2147483648)) , 
	 CHECK ((UpdateGroupIndex<=2147483647) and (UpdateGroupIndex>=-2147483648)) , 
	 CHECK ((UpdateStatus<=2147483647) and (UpdateStatus>=-2147483648)) , 
   CHECK ((SENDERID_FORCHECK<=2147483647) and (SENDERID_FORCHECK>=-2147483648)) , 
	 CHECK ((BUDGETREF<=2147483647)AND(BUDGETREF>-2147483648)) ,
   
    CHECK((PONUM<=2147483647)AND(PONUM>-2147483648)),
    CHECK((POCODE<=2147483647)AND(POCODE>-2147483648)),
    CHECK((REGIONCLS<=2147483647)AND(REGIONCLS>-2147483648)),
    CHECK((BUDGETLEVEL<=2147483647)AND(BUDGETLEVEL>-2147483648)),
    CHECK((INDEXNUM<=2147483647)AND(INDEXNUM>-2147483648)),
    CHECK((DOCTYPE<=2147483647)AND(DOCTYPE>-2147483648)),
    CHECK((AUTHCODE<=2147483647)AND(AUTHCODE>-2147483648)),
    CHECK((CALCMETHCODE<=2147483647)AND(CALCMETHCODE>-2147483648)),
    
    CHECK((KVSR<=2147483647)AND(KVSR>-2147483648)),
    CHECK((KVR<=2147483647)AND(KVR>-2147483648)),
    CHECK((KFSR<=2147483647)AND(KFSR>-2147483648)),
    CHECK((FINSOURCE<=2147483647)AND(FINSOURCE>-2147483648)),
    CHECK((MEANSTYPE<=2147483647)AND(MEANSTYPE>-2147483648)),
    CHECK((SUBSIDYCLS<=2147483647)AND(SUBSIDYCLS>-2147483648)),
    CHECK((TRANSFERTCLS<=2147483647)AND(TRANSFERTCLS>-2147483648)),
    CHECK((OKPD<=2147483647)AND(OKPD>-2147483648)),
    CHECK((DEPARTMENTCLS<=2147483647)AND(DEPARTMENTCLS>-2147483648)),
    CHECK((OBLIGSTATUS<=2147483647)AND(OBLIGSTATUS>-2147483648)),
    
    CHECK((INTFIELD00<=2147483647)AND(INTFIELD00>-2147483648)),
    CHECK((INTFIELD01<=2147483647)AND(INTFIELD01>-2147483648)),
    CHECK((INTFIELD02<=2147483647)AND(INTFIELD02>-2147483648)),
    CHECK((INTFIELD03<=2147483647)AND(INTFIELD03>-2147483648)),
    CHECK((INTFIELD04<=2147483647)AND(INTFIELD04>-2147483648)),
    CHECK((INTFIELD05<=2147483647)AND(INTFIELD05>-2147483648)),
    CHECK((INTFIELD06<=2147483647)AND(INTFIELD06>-2147483648)),
    CHECK((INTFIELD07<=2147483647)AND(INTFIELD07>-2147483648)),
    CHECK((INTFIELD08<=2147483647)AND(INTFIELD08>-2147483648)),
    CHECK((INTFIELD09<=2147483647)AND(INTFIELD09>-2147483648)),
    CHECK((INTFIELD10<=2147483647)AND(INTFIELD10>-2147483648)),
    CHECK((INTFIELD11<=2147483647)AND(INTFIELD11>-2147483648)),
    CHECK((INTFIELD12<=2147483647)AND(INTFIELD12>-2147483648)),
    CHECK((INTFIELD13<=2147483647)AND(INTFIELD13>-2147483648)),
    CHECK((INTFIELD14<=2147483647)AND(INTFIELD14>-2147483648)),
    CHECK((INTFIELD15<=2147483647)AND(INTFIELD15>-2147483648)),
    CHECK((INTFIELD16<=2147483647)AND(INTFIELD16>-2147483648)),
    CHECK((INTFIELD17<=2147483647)AND(INTFIELD17>-2147483648)),
    CHECK((INTFIELD18<=2147483647)AND(INTFIELD18>-2147483648)),
    CHECK((INTFIELD19<=2147483647)AND(INTFIELD19>-2147483648)),
    CHECK((INTFIELD20<=2147483647)AND(INTFIELD20>-2147483648)),
    CHECK((INTFIELD21<=2147483647)AND(INTFIELD21>-2147483648)),
    CHECK((INTFIELD22<=2147483647)AND(INTFIELD22>-2147483648)),
    
    
	 CONSTRAINT FK_LD_RRO_TASKREF FOREIGN KEY (TASKREF)
	  REFERENCES LAYERTASKS (ID) , 
	 CONSTRAINT FK_LD_RRO_EXECUTER FOREIGN KEY (EXECUTERUSER)
	  REFERENCES TB_DBUSERS (ID) , 
	 CONSTRAINT FK_LD_RRO_OWNER FOREIGN KEY (OWNERUSER)
	  REFERENCES TB_DBUSERS (ID) , 
	 CONSTRAINT FK_LD_RRO_LAYERREF FOREIGN KEY (LAYERREF)
	  REFERENCES LAYERS (ID) , 
   CONSTRAINT FK_LD_RRO_DEPARTMENTCLS FOREIGN KEY (DEPARTMENTCLS)
	  REFERENCES DEPARTMENTCLS (ID) , 
	 CONSTRAINT FK_LD_RRO_FACIALACCCLS FOREIGN KEY (FACIALACCCLS)
	  REFERENCES TB_FACIALACC_CLS (ID)   
)';

  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_RRO_BUDGETREF ON LAYERDATA_RRO (BUDGETREF)';
  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_RRO_LAYER ON LAYERDATA_RRO (LAYERREF, LAYERVERSION)';
/*    */
  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_RRO_POCODE ON LAYERDATA_RRO (POCODE)';
  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_RRO_PONUM ON LAYERDATA_RRO (PONUM)';
  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_RRO_BUDGETLEVEL ON LAYERDATA_RRO (BUDGETLEVEL)';
  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_RRO_INDEXNUM ON LAYERDATA_RRO (INDEXNUM)';
  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_RRO_DOCDATE ON LAYERDATA_RRO (DOCDATE)';
  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_RRO_DOCTYPE ON LAYERDATA_RRO (DOCTYPE)';

/*   */
  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_RRO_KVSR ON LAYERDATA_RRO (KVSR)';
  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_RRO_KFSR ON LAYERDATA_RRO (KFSR)';
  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_RRO_KCSR ON LAYERDATA_RRO (KCSR)';
  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_RRO_KVR ON LAYERDATA_RRO (KVR)';
  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_RRO_KESR ON LAYERDATA_RRO (KESR)';
  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_RRO_SUBKESR ON LAYERDATA_RRO (SUBKESR)';
  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_RRO_MEANSTYPE ON LAYERDATA_RRO (MEANSTYPE)';
  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_RRO_FACT ON LAYERDATA_RRO (FACT)';
  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_RRO_DIRECTION ON LAYERDATA_RRO (DIRECTIONCLS)';
  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_RRO_REGIONCLS ON LAYERDATA_RRO (REGIONCLS)';
  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_RRO_SUBSIDYCLS ON LAYERDATA_RRO (SUBSIDYCLS)';
  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_RRO_CS ON LAYERDATA_RRO (TransfertCls)';
  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_RRO_NP ON LAYERDATA_RRO (NAZPROJ)';
  EXECUTE IMMEDIATE 'CREATE INDEX IDX_LD_RRO_OST ON LAYERDATA_RRO (OBLIGSTATUS)';

  EXECUTE IMMEDIATE 'GRANT ALL ON LAYERDATA_RRO TO PUBLIC';
  
  EXECUTE IMMEDIATE 'COMMIT WORK';

END IF;

END;
/


CREATE OR REPLACE TRIGGER TR_LD_RRO_AD after delete ON LayerData_RRO FOR EACH ROW
begin

-- - - - - - - - - - - - -
-- AD_500
-- Create 05.09.2005
-- - - - - - - - - - - - -

    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (174, :old.ID, SYSDATE);
    
end;

/

CREATE OR REPLACE TRIGGER TR_LD_RRO_AI after insert ON LayerData_RRO FOR EACH ROW
begin

-- - - - - - - - - - - - -
-- AI_500
-- Create 05.09.2005
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 174) and (RecordID = :new.ID);
  
end;

/

CREATE OR REPLACE TRIGGER TR_LD_RRO_AU after update ON LayerData_RRO FOR EACH ROW
begin

-- - - - - - - - - - - - -
-- AU_500
-- Create 05.09.2005
-- - - - - - - - - - - - -

  if (:new.ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (174, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=174) and (RecordId=:new.ID);
  end if;
  
end;

/

CREATE OR REPLACE TRIGGER TR_LD_RRO_BI
 BEFORE
  INSERT
 ON LayerData_RRO
 FOR EACH ROW
declare
  fac NUMBER(10);
begin

-- - - - - - - - - - - - -
-- BI_(0)
-- Create 05.09.2005
-- Last Update 22.05.2009
-- - - - - - - - - - - - -

    if (:new.id is null) then select g_Shared.nextval into :new.Id from DUAL; end if;
    if (:new.LayerVersion is null) then :new.LayerVersion := 0; end if;
    if (:new.ExecuterUser is null) then :new.ExecuterUser := :new.OwnerUser; end if;
    if ((:new.FacialAccCls is null) and (:new.TaskRef is not null)) then
      BEGIN
        select FacialAccCls into fac from LayerTasks where ID = :new.TaskRef;
        :new.FacialAccCls := fac;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    end if;
    if (:new.TaskRef is not null) then
      BEGIN
        select LayerVersion, DocStateRef, AcceptDate, RejectDate, OwnerUser, ExecuterUser
          into :new.LayerVersion, :new.DocStateRef, :new.AcceptDate, :new.RejectDate,
          :new.OwnerUser, :new.ExecuterUser
        from LayerTasks where ID = :new.TaskRef;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          :new.LayerVersion := NULL;
          :new.DocStateRef := NULL;
          :new.AcceptDate := NULL;
          :new.RejectDate := NULL;
          :new.OwnerUser := NULL;
          :new.ExecuterUser := NULL;
      END;  
    end if;
    
-- - - - - - - - - - - - -
-- BI_500
-- Create 05.09.2005
-- - - - - - - - - - - - -
  :NEW.CreateDate := SYSDATE;
  :NEW.UpdateDate := :NEW.CreateDate;
  :NEW.CreaterUser := USER;
  :NEW.UpdaterUser := USER;
end;

/

CREATE OR REPLACE TRIGGER TR_LD_RRO_BU
 BEFORE
  UPDATE
 ON LayerData_RRO
 FOR EACH ROW
begin

-- - - - - - - - - - - - -
-- BU_(0)
-- Create 05.09.2005
-- - - - - - - - - - - - -

    if (:new.LayerVersion is null) then :new.LayerVersion := 0; end if;
    if (:new.ExecuterUser is null) then :new.ExecuterUser := :new.OwnerUser; end if;
    
-- - - - - - - - - - - - -
-- BU_700
-- Create 05.09.2005
-- - - - - - - - - - - - -

  if (:new.RVersion is null) then
    :new.RVersion := 1;
  elsif ((:new.RVersion = -1) and (:old.RVersion <> -1)) then
    :new.RVersion := :old.RVersion;
  else
    :new.RVersion := :old.RVersion+1;
  end if;

end;

/
CREATE OR REPLACE TRIGGER TR_LD_RRO_BU_500 before update on LayerData_RRO for each row
begin
-- - - - - - - - - - - - -
-- BU_500
-- - - - - - - - - - - - -
    :new.UpdateDate := SYSDATE;
    :new.UpdaterUser := User;
end;

/

